



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SQL Server 事务、异常和游标</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SQL Server 事务、异常和游标</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 03:02:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>转自：http://www.cnblogs.com/hoojo/archive/2011/07/19/2110325.html</p>
<p>&Oslash; 事务</p>
<p>在数据库中有时候需要把多个步骤的指令当作一个整体来运行，这个整体要么全部成功，要么全部失败，这就需要用到事务。</p>
<p>1、 事务的特点</p>
<p>事务有若干条T-SQL指令组成，并且所有的指令昨晚一个整体提交给数据库系统，执行时，这组指令要么全部执行完成，要么全部取消。因此，事务是一个不可分割的逻辑单元。</p>
<p>事务有4个属性：原子性（Atomicity）、一致性（Consistency）、隔离性（Isolation）以及持久性（Durability），也称作事务的ACID属性。</p>
<p><strong>原子性</strong>：事务内的所有工作要么全部完成，要么全部不完成，不存在只有一部分完成的情况。</p>
<p><strong>一致性</strong>：事务内的然后操作都不能违反数据库的然后约束或规则，事务完成时有内部数据结构都必须是正确的。</p>
<p><strong>隔离性</strong>：事务直接是相互隔离的，如果有两个事务对同一个数据库进行操作，比如读取表数据。任何一个事务看到的所有内容要么是其他事务完成之前的状态，要么是其他事务完成之后的状态。一个事务不可能遇到另一个事务的中间状态。</p>
<p><strong>持久性</strong>：事务完成之后，它对数据库系统的影响是持久的，即使是系统错误，重新启动系统后，该事务的结果依然存在。</p>
<p>2、 事务的模式</p>
<p>a、 显示事务</p>
<p>显示事务就是用户使用T-SQL明确的定义事务的开始（begin transaction）和提交（commit transaction）或回滚事务（rollback transaction）</p>
<p>b、 自动提交事务</p>
<p>自动提交事务是一种能够自动执行并能自动回滚事务，这种方式是T-SQL的默认事务方式。例如在删除一个表记录的时候，如果这条记录有主外键关系的时候，删除就会受主外键约束的影响，那么这个删除就会取消。</p>
<p>可以设置事务进入隐式方式：set implicit_transaction on;</p>
<p>c、 隐式事务</p>
<p>隐式事务是指当事务提交或回滚后，SQL Server自动开始事务。因此，隐式事务不需要使用begin transaction显示开始，只需直接失业提交事务或回滚事务的T-SQL语句即可。</p>
<p>使用时，需要设置set implicit_transaction on语句，将隐式事务模式打开，下一个语句会启动一个新的事物，再下一个语句又将启动一个新事务。</p>
<p>3、 事务处理</p>
<p>常用T-SQL事务语句：</p>
<p>a、 begin transaction语句</p>
<p>开始事务，而@@trancount全局变量用来记录事务的数目值加1，可以用@@error全局变量记录执行过程中的错误信息，如果没有错误可以直接提交事务，有错误可以回滚。</p>
<p>b、 commit transaction语句</p>
<p>回滚事务，表示一个隐式或显示的事务的结束，对数据库所做的修改正式生效。并将@@trancount的值减1；</p>
<p>c、 rollback transaction语句</p>
<p>回滚事务，执行rollback tran语句后，数据会回滚到begin tran的时候的状态</p>
<p>4、 事务的示例</p>
<div>
<pre class="prettyprint linenums">--开始事务<br />begin transaction tran_bank;<br />declare @tran_error int;<br />    set @tran_error = 0;<br />    begin try<br />        update bank set totalMoney = totalMoney - 10000 where userName = 'jack';        <br />        set @tran_error = @tran_error + @@error;<br />        update bank set totalMoney = totalMoney + 10000 where userName = 'jason';<br />        set @tran_error = @tran_error + @@error;<br />    end try<br />    begin catch        <br />        print '出现异常，错误编号：' + convert(varchar, error_number()) + '， 错误消息：' + error_message(); <br />        set @tran_error = @tran_error + 1;<br />    end catch<br />if (@tran_error &gt; 0)<br />    begin<br />        --执行出错，回滚事务<br />        rollback tran;<br />        print '转账失败，取消交易';<br />    end<br />else<br />    begin<br />        --没有异常，提交事务<br />        commit tran;<br />        print '转账成功';<br />    end<br />go</pre>
</div>
<div>&nbsp;</div>
<p>&Oslash; 异常</p>
<p>在程序中，有时候完成一些Transact-SQL会出现错误、异常信息。如果我们想自己处理这些异常信息的话，需要手动捕捉这些信息。那么我们可以利用try catch完成。</p>
<p>TRY&hellip;CATCH 构造包括两部分：一个 TRY 块和一个 CATCH 块。如果在 TRY 块中所包含的 Transact-SQL 语句中检测到错误条件，控制将被传递到 CATCH 块（可在此块中处理该错误）。</p>
<p>CATCH 块处理该异常错误后，控制将被传递到 END CATCH 语句后面的第一个 Transact-SQL 语句。如果 END CATCH 语句是存储过程或触发器中的最后一条语句，控制将返回到调用该存储过程或触发器的代码。将不执行 TRY 块中生成错误的语句后面的 Transact-SQL 语句。</p>
<p>如果 TRY 块中没有错误，控制将传递到关联的 END CATCH 语句后紧跟的语句。如果 END CATCH 语句是存储过程或触发器中的最后一条语句，控制将传递到调用该存储过程或触发器的语句。</p>
<p>TRY 块以 BEGIN TRY 语句开头，以 END TRY 语句结尾。在 BEGIN TRY 和 END TRY 语句之间可以指定一个或多个 Transact-SQL 语句。CATCH 块必须紧跟 TRY 块。CATCH 块以 BEGIN CATCH 语句开头，以 END CATCH 语句结尾。在 Transact-SQL 中，每个 TRY 块仅与一个 CATCH 块相关联。</p>
<p># 错误函数</p>
<div>
<pre class="prettyprint linenums">TRY...CATCH 使用错误函数来捕获错误信息。<br />    ERROR_NUMBER() 返回错误号。<br />    ERROR_MESSAGE() 返回错误消息的完整文本。此文本包括为任何可替换参数（如长度、对象名称或时间）提供的值。<br />    ERROR_SEVERITY() 返回错误严重性。<br />    ERROR_STATE() 返回错误状态号。<br />    ERROR_LINE() 返回导致错误的例程中的行号。<br />    ERROR_PROCEDURE() 返回出现错误的存储过程或触发器的名称。</pre>
</div>
<div>&nbsp;</div>
<p>示例</p>
<div>
<pre class="prettyprint linenums">--错误消息存储过程<br />if (object_id('proc_error_info') is not null)<br />    drop procedure proc_error_info<br />go<br />create proc proc_error_info<br />as<br />    select <br />        error_number() '错误编号',<br />        error_message() '错误消息',<br />        error_severity() '严重性',<br />        error_state() '状态好',<br />        error_line() '错误行号',<br />        error_procedure() '错误对象(存储过程或触发器)名称';<br />go</pre>
</div>
<p># 示例：用异常处理错误信息</p>
<div>
<pre class="prettyprint linenums">--简单try catch示例<br />begin try<br />    select 1 / 0;<br />end try<br />begin catch<br />    exec proc_error_info; --调用错误消息存储过程<br />end catch<br />go</pre>
</div>
<p># 示例：异常能处理的错误信息</p>
<div>
<pre class="prettyprint linenums">--<br />--简单try catch示例，无法处理错误<br />begin try<br />    select * * from student;<br />end try<br />begin catch<br />    exec proc_error_info;<br />end catch<br />go<br />--<br />--简单try catch示例，不处理错误(不存在的表对象)<br />begin try<br />    select * from st;<br />end try<br />begin catch<br />    exec proc_error_info;<br />end catch<br />go<br />--<br />--异常处理，能处理存储过程（触发器）中（不存在表对象）的错误信息<br />if (object_id('proc_select') is not null)<br />    drop procedure proc_select<br />go<br />create proc proc_select<br />as<br />    select * from st;<br />go<br />begin try<br />    exec proc_select;<br />end try<br />begin catch    <br />    exec proc_error_info;<br />end catch<br />go</pre>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<p>异常不能处理编译期的错误，如语法错误。以及重编译造成部分名称对象得不到正确解析的时候所出现的错误。</p>
<p># 示例：无法提交的事务</p>
<div>
<pre class="prettyprint linenums">--创建临时用表<br />if (object_id('temp_tab', 'u') is not null)<br />    drop table temp_tab<br />go<br />create table temp_tab(<br />    id int primary key identity(100000, 1),<br />    name varchar(200)<br />)<br />go

begin try<br />    begin tran;<br />    --没有createTime字段<br />    alter table temp_tab drop column createTime;<br />    commit tran;<br />end try<br />begin catch<br />    exec proc_error_info;--显示异常信息<br />    if (xact_state() = -1)<br />    begin<br />        print '会话具有活动事务，但出现了致使事务被归类为无法提交的事务的错误。'<br />            + '会话无法提交事务或回滚到保存点；它只能请求完全回滚事务。'<br />            + '会话在回滚事务之前无法执行任何写操作。会话在回滚事务之前只能执行读操作。'<br />            + '事务回滚之后，会话便可执行读写操作并可开始新的事务。';<br />    end<br />    else if (xact_state() = 0)<br />    begin<br />        print '会话没有活动事务。';<br />    end<br />    else if (xact_state() = 1)<br />    begin<br />        print '会话具有活动事务。会话可以执行任何操作，包括写入数据和提交事务。';<br />    end<br />end catch<br />go</pre>
</div>
<p># 示例：处理异常日志信息</p>
<div>
<pre class="prettyprint linenums">--<br />---异常、错误信息表<br />if (object_id('errorLog', 'U') is not null)<br />    drop table errorLog<br />go<br />create table errorLog(<br />    errorLogID int primary key identity(100, 1),    --ErrorLog 行的主键。<br />    errorTime datetime default getDate(),            --发生错误的日期和时间。<br />    userName sysname default current_user,            --执行发生错误的批处理的用户。<br />    errorNumber int,                                --发生的错误的错误号。<br />    errorSeverity int,                                --发生的错误的严重性。<br />    errorState int,                                    --发生的错误的状态号。<br />    errorProcedure nvarchar(126),                    --发生错误的存储过程或触发器的名称。<br />    errorLine int,                                    --发生错误的行号。<br />    errorMessage nvarchar(4000)<br />)<br />go<br />--<br />--存储过程：添加异常日志信息<br />if (object_id('proc_add_exception_log', 'p') is not null)<br />    drop proc proc_add_exception_log<br />go<br />create proc proc_add_exception_log(@logId int = 0 output)<br />as<br />begin<br />    set nocount on;<br />    set @logId = 0;<br />    begin try<br />        if (error_number() is null)<br />            return;

        if (xact_state() = -1)<br />        begin<br />            print '会话具有活动事务，但出现了致使事务被归类为无法提交的事务的错误。'<br />                + '会话无法提交事务或回滚到保存点；它只能请求完全回滚事务。'<br />                + '会话在回滚事务之前无法执行任何写操作。会话在回滚事务之前只能执行读操作。'<br />                + '事务回滚之后，会话便可执行读写操作并可开始新的事务。';<br />        end<br />        else if (xact_state() = 0)<br />        begin<br />            print '会话没有活动事务。';<br />        end<br />        else if (xact_state() = 1)<br />        begin<br />            print '会话具有活动事务。会话可以执行任何操作，包括写入数据和提交事务。';<br />        end

        --添加日志信息<br />        insert into errorLog values(getDate(), <br />            current_user, error_number(), <br />            error_severity(), error_state(), <br />            error_procedure(), <br />            error_line(), error_message());<br />        --设置自增值<br />        select @logId = @@identity;<br />    end try<br />    begin catch<br />        print '添加异常日志信息出现错误';<br />        exec proc_error_info;--显示错误信息<br />        return -1;<br />    end catch<br />end<br />go<br />--<br />---处理异常信息示例<br />declare @id int;<br />begin try<br />    begin tran;<br />    --删除带有外键的记录信息<br />    delete classes where id = 1;<br />    commit tran;<br />end try<br />begin catch<br />    exec proc_error_info;--显示错误信息<br />    if (xact_state() &lt;&gt; 0)<br />    begin<br />        rollback tran;<br />    end<br />    exec proc_add_exception_log @id output<br />end catch<br />select * from errorLog where errorLogID = @id;<br />go</pre>
</div>
<p>&Oslash; 游标</p>
<p>游标可以对一个select的结果集进行处理，或是不需要全部处理，就会返回一个对记录集进行处理之后的结果。</p>
<p>1、游标实际上是一种能从多条数据记录的结果集中每次提取一条记录的机制。游标可以完成：</p>
<p># 允许定位到结果集中的特定行</p>
<p># 从结果集的当前位置检索一行或多行数据</p>
<p># 支持对结果集中当前位置的进行修改</p>
<p>由于游标是将记录集进行一条条的操作，所以这样给服务器增加负担，一般在操作复杂的结果集的情况下，才使用游标。SQL Server 2005有三种游标：T-SQL游标、API游标、客户端游标。</p>
<p>2、游标的基本操作</p>
<p>游标的基本操作有定义游标、打开游标、循环读取游标、关闭游标、删除游标。</p>
<p>A、 定义游标</p>
<div>
<pre class="prettyprint linenums">declare cursor_name    --游标名称<br />cursor [local | global]    --全局、局部<br />[forward only | scroll]    --游标滚动方式<br />[read_only | scroll_locks | optimistic]    --读取方式<br />for select_statements                    --查询语句<br />[for update | of column_name ...]        --修改字段</pre>
</div>
<p>参数：</p>
<p>forward only | scroll：前一个参数，游标只能向后移动；后一个参数，游标可以随意移动</p>
<p>read_only：只读游标</p>
<p>scroll_locks：游标锁定，游标在读取时，数据库会将该记录锁定，以便游标完成对记录的操作</p>
<p>optimistic：该参数不会锁定游标；此时，如果记录被读入游标后，对游标进行更新或删除不会超过</p>
<p>B、 打开游标</p>
<p>open cursor_name;</p>
<p>游标打开后，可以使用全局变量@@cursor_rows显示读取记录条数</p>
<p>C、 检索游标</p>
<p>fetch cursor_name;</p>
<p>检索方式如下：</p>
<p>fetch first; 读取第一行</p>
<p>fetch next; 读取下一行</p>
<p>fetch prior; 读取上一行</p>
<p>fetch last; 读取最后一行</p>
<p>fetch absolute n; 读取某一行</p>
<p>如果n为正整数，则读取第n条记录</p>
<p>如果n为负数，则倒数提取第n条记录</p>
<p>如果n为，则不读取任何记录</p>
<p>fetch pelative n</p>
<p>如果n为正整数，则读取上次读取记录之后第n条记录</p>
<p>如果n为负数，则读取上次读取记录之前第n条记录</p>
<p>如果n为，则读取上次读取的记录</p>
<p>D、 关闭游标</p>
<p>close cursor_name;</p>
<p>E、 删除游标</p>
<p>deallocate cursor_name;</p>
<p>3、游标操作示例</p>
<pre class="prettyprint linenums">--创建一个游标<br />declare cursor_stu cursor scroll for<br />    select id, name, age from student;<br />--打开游标<br />open cursor_stu;<br />--存储读取的值<br />declare @id int,<br />        @name nvarchar(20),<br />        @age varchar(20);<br />--读取第一条记录<br />fetch first from cursor_stu into @id, @name, @age;<br />--循环读取游标记录<br />print '读取的数据如下：';<br />--全局变量<br />while (@@fetch_status = 0)<br />begin<br />    print '编号：' + convert(char(5), @id) + ', 名称：' + @name + ', 类型：' + @age;<br />    --继续读取下一条记录<br />    fetch next from cursor_stu into @id, @name, @age;<br />end<br />--关闭游标<br />close area_cursor;

--删除游标<br />--deallocate area_cursor;</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq124r09.html">C&plus;&plus; 复制控制之复制构造函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7rn5j8.html">linux环境内存分配原理 mallocinfo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1n16k8.html">python字典的常用操作方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm1j119.html">改变ListCtrl某行的背景色或者字体颜色</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z5e369.html">XenServer6&period;2详细安装步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zlzl59.html">SQLserver行转列与列转行</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm63wx9.html">WifiDog系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg500m8.html">Java之多线程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo3041q.html">windows域与工作组概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gek3l48.html">SpringMVC框架学习笔记（5）&mdash;&mdash;数据处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zr4me9.html">jenkins 自动化部署执行shell</a>
		</li>
						<li><a href="https://www.batexi.com/a/96px4en8.html">php设计模式--简单介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzk1m48.html">排序算法&lpar;sorting&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geno2e8.html">无法加载协定为&OpenCurlyDoubleQuote;NM3&period;IClrService&rdquo;的终结点配置部分，因为找到了该协定的多个终结点配置。请按名称指示首选的终结点配置部分</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o11doeq.html">Python爬取淘宝店铺和评论</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy2gzx9.html">洛谷P3233 世界树</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlkxw39.html">IP 解析器（IpParser） test 和 生产环境 实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql16p6e9.html">关于Amazon&period;com Seller 网络以及IP地址更换 官方回答</a>
		</li>
						<li><a href="https://www.batexi.com/a/9532kpe8.html">ssh&colon; Could not resolve hostname问题终于解决了？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx20vrd8.html">关于微信小程序的场景值</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/39r7pg78.html">gcc 使用 stdio&period;h</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pg5wy9.html">在CentOS上搭建Storm集群</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pg5ez9.html">Odoo Web Service API</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96dw2v8.html">JSP开发模式2&lowbar;JSP&sol;Servlet&sol;JavaBean（简单注册功能）</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k2erj8.html">python 2&period;4 与 python 3&period;0 的比较</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qygz7gq.html">AFN中的PATCH 和 DELETE 请求方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mk32pq.html">MyElipes遇到 source not found解决方案&lpar;查看&period;class文件源码一劳永逸的解决方法&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxyp5z9.html">mac上运行appium提示错误Encountered internal error running command 解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k2yg58.html">无法在Web服务器上启动调试&comma;已附加了一个调试器</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4dxgnq.html">使用dom元素和jquery元素实现简单增删改的练习</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
